import * as jspb from "google-protobuf"

import * as google_protobuf_any_pb from 'google-protobuf/google/protobuf/any_pb';

export class SearchCriteria extends jspb.Message {
  getKey(): string;
  setKey(value: string): void;

  getOperation(): SearchOperation;
  setOperation(value: SearchOperation): void;

  getValue(): google_protobuf_any_pb.Any | undefined;
  setValue(value?: google_protobuf_any_pb.Any): void;
  hasValue(): boolean;
  clearValue(): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SearchCriteria.AsObject;
  static toObject(includeInstance: boolean, msg: SearchCriteria): SearchCriteria.AsObject;
  static serializeBinaryToWriter(message: SearchCriteria, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SearchCriteria;
  static deserializeBinaryFromReader(message: SearchCriteria, reader: jspb.BinaryReader): SearchCriteria;
}

export namespace SearchCriteria {
  export type AsObject = {
    key: string,
    operation: SearchOperation,
    value?: google_protobuf_any_pb.Any.AsObject,
  }
}

export enum SearchOperation { 
  EQUAL = 0,
  NOT_EQUAL = 1,
  GREATER_THAN = 2,
  GREATER_THAN_EQUAL = 3,
  LESS_THAN = 4,
  LESS_THAN_EQUAL = 5,
  LIKE = 6,
  STARTS_WITH = 7,
  ENDS_WITH = 8,
  CONTAINS = 9,
}
